/*
 * String API. Uses buffer API. In namespace p_str_. 
 *
 * Copyright (c) 2005, Adam Gleave
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the 
 *     documentation and/or other materials provided with the distribution.
 *  3. Neither the name of the copyright holders nor the names of its
 *     contributors may be used to endorse or promote products derived from
 *     this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT OWNER AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/* 
 * @UNSAFE: WHOLE FILE
 */

#include <stdio.h>

#include "buffer.h"
#include "bufdang.h"
#include "string.h"

#define ROK P_RET_OK
#define RFAIL P_RET_FAIL

/* FIXME: No printf function is implemented. This should change.
 * It may have to be a host wrapper, but I certainly hope not. */
 
/* DANGEROUS Functions. */

/* 
 * @WARNING: These functions are baad things and proboably shouldn't be used. 
 */

int p_str_nulterm(p_arr *p_str)
{
  size_t used = p_buf_get_used(p_str);
  const char *str;
  
  /* Does string not exist? (p_buf_read_pos() will terminate us, this is
   * to stop integer overflow) */
  if (used > 0)
    used -= 1;
  
  if ((str = p_buf_read_pos(p_str, used, 1)) == NULL)
    return RFAIL;
  
  /* Is it already nul terminated? */
  if (*str == '\0')
    return ROK;
  
  if (p_buf_write(p_str, used+1, "", 1) != ROK)
    return RFAIL;
  
  return ROK;
}
